
#ifndef __BLOB_H__
#define __BLOB_H__
#include "mal.h"
#include "mal_exception.h"

typedef struct blob {
	size_t nitems;
	/*unsigned */ char data[1];
} blob;

#define sqlblob blob

#ifdef WIN32
#ifndef LIBBLOB
#define blob_export extern __declspec(dllimport)
#else
#define blob_export extern __declspec(dllexport)
#endif
#else
#define blob_export extern
#endif

blob_export int TYPE_blob;
blob_export int TYPE_sqlblob;

blob_export size_t blobsize(size_t nitems);
blob_export int sqlblob_tostr(str *tostr, int *l, blob *p);
blob_export int sqlblob_fromstr(char *instr, int *l, blob **val);

#endif /* __BLOB_H__ */

