
#ifndef XML_H
#define XML_H

#include "mal_config.h"
#include <gdk.h>
#include "mal.h"
#include "mal_instruction.h"
#include "mal_exception.h"

typedef str xml;

#ifdef WIN32
#ifndef LIBXML
#define xml_export extern __declspec(dllimport)
#else
#define xml_export extern __declspec(dllexport)
#endif
#else
#define xml_export extern
#endif

xml_export int TYPE_xml;

xml_export int XMLfromString(str src, int *len, xml *x);
xml_export int XMLtoString(str *s, int *len, str src);

xml_export str XMLxml2str(str *s, xml *x);
xml_export str XMLstr2xml(xml *x, str *s);
xml_export str XMLxml2xml(xml *x, xml *s);
xml_export str XMLdocument(xml *x, str *s);
xml_export str XMLcontent(xml *x, str *s);
xml_export str XMLisdocument(bit *x, str *s);
xml_export str XMLcomment(xml *x, str *s);
xml_export str XMLpi(xml *x, str *nme, str *s);
xml_export str XMLroot(str *x, str *v, str *version, str *standalone);
xml_export str XMLparse(xml *x, str *s, str *option);
xml_export str XMLattribute(xml *ret, str *name, str *val);
xml_export str XMLelement(xml *ret, str *name, str *nspace, xml *attr, xml *val);
xml_export str XMLelementSmall(xml *ret, str *name, xml *val);
xml_export str XMLconcat(xml *ret, xml *left, xml *right);
xml_export str XMLforest(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);

xml_export str XMLprelude(void);

#endif /* XML_H */

