
#ifndef _CRACKERS_AVL_TREE_H_
#define _CRACKERS_AVL_TREE_H_

#ifdef LIBCRACKERS
/* Signatures shared within the crackers module/library */

int Height(struct Node * x);
struct Node * SingleRotateLeft(int m, struct Node * node);
struct Node * SingleRotateRight(int m, struct Node * node);
struct Node * DoubleRotateLeft(int m, struct Node * node);
struct Node * DoubleRotateRight(int m, struct Node * node);
struct Node * findPreviousPieceWalkingBack(struct Node * node);
struct Node * findNextPiece(struct Node * node);
void FreeAVLTree(struct Node * current);
void printAVLTree(struct Node * current, BAT *b, BUN base);
void printAVLTreeIncrementalSideways(struct Node * current, BAT *b, BUN base);
struct Node * getFirstNode(struct Node * node);
struct Node * getLastNode(struct Node * node);
struct Node * getPreviousNodeAny(struct Node * current);
struct Node * getPreviousNonLocalNode(struct Node * current);
struct Node * getNextNonLocalNode(struct Node * current);





bit GetLow_chr(chr  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetHgh_chr(chr  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetLowNodes_chr(chr  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
bit GetHghNodes_chr(chr  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
struct Node * InsertTree_chr(int m, oid indexPosition, chr value, bit inclusive, oid crackPosition, struct Node * current, BAT * b, BUN base, struct Node **newNode);
struct Node *
InsertTreeIncrementalSideways_chr(int m, oid indexPosition, chr value, bit inclusive, oid crackPosition, oid crackPositionLocal, struct Node * current, BAT * b, BUN base, struct Node **newNode, bit localBound, bit first, int pieceBAT);
struct Node * findNodeH_chr(chr  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * next);
struct Node * findNodeL_chr(chr  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * prev);
void PartiallyLazyFreeAVLTree_chr(struct Node * current, chr value, BAT *b, BUN base);




bit GetLow_sht(sht  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetHgh_sht(sht  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetLowNodes_sht(sht  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
bit GetHghNodes_sht(sht  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
struct Node * InsertTree_sht(int m, oid indexPosition, sht value, bit inclusive, oid crackPosition, struct Node * current, BAT * b, BUN base, struct Node **newNode);
struct Node *
InsertTreeIncrementalSideways_sht(int m, oid indexPosition, sht value, bit inclusive, oid crackPosition, oid crackPositionLocal, struct Node * current, BAT * b, BUN base, struct Node **newNode, bit localBound, bit first, int pieceBAT);
struct Node * findNodeH_sht(sht  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * next);
struct Node * findNodeL_sht(sht  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * prev);
void PartiallyLazyFreeAVLTree_sht(struct Node * current, sht value, BAT *b, BUN base);




bit GetLow_int(int  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetHgh_int(int  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetLowNodes_int(int  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
bit GetHghNodes_int(int  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
struct Node * InsertTree_int(int m, oid indexPosition, int value, bit inclusive, oid crackPosition, struct Node * current, BAT * b, BUN base, struct Node **newNode);
struct Node *
InsertTreeIncrementalSideways_int(int m, oid indexPosition, int value, bit inclusive, oid crackPosition, oid crackPositionLocal, struct Node * current, BAT * b, BUN base, struct Node **newNode, bit localBound, bit first, int pieceBAT);
struct Node * findNodeH_int(int  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * next);
struct Node * findNodeL_int(int  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * prev);
void PartiallyLazyFreeAVLTree_int(struct Node * current, int value, BAT *b, BUN base);




bit GetLow_lng(lng  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetHgh_lng(lng  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetLowNodes_lng(lng  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
bit GetHghNodes_lng(lng  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
struct Node * InsertTree_lng(int m, oid indexPosition, lng value, bit inclusive, oid crackPosition, struct Node * current, BAT * b, BUN base, struct Node **newNode);
struct Node *
InsertTreeIncrementalSideways_lng(int m, oid indexPosition, lng value, bit inclusive, oid crackPosition, oid crackPositionLocal, struct Node * current, BAT * b, BUN base, struct Node **newNode, bit localBound, bit first, int pieceBAT);
struct Node * findNodeH_lng(lng  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * next);
struct Node * findNodeL_lng(lng  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * prev);
void PartiallyLazyFreeAVLTree_lng(struct Node * current, lng value, BAT *b, BUN base);




bit GetLow_flt(flt  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetHgh_flt(flt  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetLowNodes_flt(flt  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
bit GetHghNodes_flt(flt  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
struct Node * InsertTree_flt(int m, oid indexPosition, flt value, bit inclusive, oid crackPosition, struct Node * current, BAT * b, BUN base, struct Node **newNode);
struct Node *
InsertTreeIncrementalSideways_flt(int m, oid indexPosition, flt value, bit inclusive, oid crackPosition, oid crackPositionLocal, struct Node * current, BAT * b, BUN base, struct Node **newNode, bit localBound, bit first, int pieceBAT);
struct Node * findNodeH_flt(flt  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * next);
struct Node * findNodeL_flt(flt  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * prev);
void PartiallyLazyFreeAVLTree_flt(struct Node * current, flt value, BAT *b, BUN base);




bit GetLow_dbl(dbl  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetHgh_dbl(dbl  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetLowNodes_dbl(dbl  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
bit GetHghNodes_dbl(dbl  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
struct Node * InsertTree_dbl(int m, oid indexPosition, dbl value, bit inclusive, oid crackPosition, struct Node * current, BAT * b, BUN base, struct Node **newNode);
struct Node *
InsertTreeIncrementalSideways_dbl(int m, oid indexPosition, dbl value, bit inclusive, oid crackPosition, oid crackPositionLocal, struct Node * current, BAT * b, BUN base, struct Node **newNode, bit localBound, bit first, int pieceBAT);
struct Node * findNodeH_dbl(dbl  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * next);
struct Node * findNodeL_dbl(dbl  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * prev);
void PartiallyLazyFreeAVLTree_dbl(struct Node * current, dbl value, BAT *b, BUN base);




bit GetLow_date(date  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetHgh_date(date  x, bit inclusive, struct Node * current, BAT *b, BUN base, oid *p1, oid *p2, oid previous, oid next);
bit GetLowNodes_date(date  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
bit GetHghNodes_date(date  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node **p1, struct Node **p2, struct Node *previous, struct Node *next);
struct Node * InsertTree_date(int m, oid indexPosition, date value, bit inclusive, oid crackPosition, struct Node * current, BAT * b, BUN base, struct Node **newNode);
struct Node *
InsertTreeIncrementalSideways_date(int m, oid indexPosition, date value, bit inclusive, oid crackPosition, oid crackPositionLocal, struct Node * current, BAT * b, BUN base, struct Node **newNode, bit localBound, bit first, int pieceBAT);
struct Node * findNodeH_date(date  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * next);
struct Node * findNodeL_date(date  x, bit inclusive, struct Node * current, BAT *b, BUN base, struct Node * prev);
void PartiallyLazyFreeAVLTree_date(struct Node * current, date value, BAT *b, BUN base);






#endif

#endif /* _CRACKERS_AVL_TREE_H */

