
#ifndef _CRACKERS_UPDATES_H_
#define _CRACKERS_UPDATES_H_

/* Signatures shared within the crackers module/library */

str appendInsertions(int *new, int position);





/* mergeInsertionOperations */
str mergeInsertionsB_chr(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBGradually_chr(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBRipple_chr(BAT *b, BAT *u, oid startPosition, oid endPosition, chr *hgh, bit inclusive, int position);
str mergeDeletions_chr(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGradually_chr(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGraduallyRipple_chr(int *bid, int *del, oid startPosition, oid endPosition, chr *lowV, bit inclusiveL, chr *hghV, bit inclusiveH);




/* mergeInsertionOperations */
str mergeInsertionsB_sht(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBGradually_sht(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBRipple_sht(BAT *b, BAT *u, oid startPosition, oid endPosition, sht *hgh, bit inclusive, int position);
str mergeDeletions_sht(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGradually_sht(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGraduallyRipple_sht(int *bid, int *del, oid startPosition, oid endPosition, sht *lowV, bit inclusiveL, sht *hghV, bit inclusiveH);




/* mergeInsertionOperations */
str mergeInsertionsB_int(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBGradually_int(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBRipple_int(BAT *b, BAT *u, oid startPosition, oid endPosition, int *hgh, bit inclusive, int position);
str mergeDeletions_int(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGradually_int(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGraduallyRipple_int(int *bid, int *del, oid startPosition, oid endPosition, int *lowV, bit inclusiveL, int *hghV, bit inclusiveH);




/* mergeInsertionOperations */
str mergeInsertionsB_lng(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBGradually_lng(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBRipple_lng(BAT *b, BAT *u, oid startPosition, oid endPosition, lng *hgh, bit inclusive, int position);
str mergeDeletions_lng(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGradually_lng(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGraduallyRipple_lng(int *bid, int *del, oid startPosition, oid endPosition, lng *lowV, bit inclusiveL, lng *hghV, bit inclusiveH);




/* mergeInsertionOperations */
str mergeInsertionsB_flt(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBGradually_flt(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBRipple_flt(BAT *b, BAT *u, oid startPosition, oid endPosition, flt *hgh, bit inclusive, int position);
str mergeDeletions_flt(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGradually_flt(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGraduallyRipple_flt(int *bid, int *del, oid startPosition, oid endPosition, flt *lowV, bit inclusiveL, flt *hghV, bit inclusiveH);




/* mergeInsertionOperations */
str mergeInsertionsB_dbl(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBGradually_dbl(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBRipple_dbl(BAT *b, BAT *u, oid startPosition, oid endPosition, dbl *hgh, bit inclusive, int position);
str mergeDeletions_dbl(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGradually_dbl(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGraduallyRipple_dbl(int *bid, int *del, oid startPosition, oid endPosition, dbl *lowV, bit inclusiveL, dbl *hghV, bit inclusiveH);




/* mergeInsertionOperations */
str mergeInsertionsB_date(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBGradually_date(int *bid, int *new, oid startPosition, oid endPosition);
str mergeInsertionsBRipple_date(BAT *b, BAT *u, oid startPosition, oid endPosition, date *hgh, bit inclusive, int position);
str mergeDeletions_date(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGradually_date(int *bid, int *del, oid startPosition, oid endPosition);
str mergeDeletionsGraduallyRipple_date(int *bid, int *del, oid startPosition, oid endPosition, date *lowV, bit inclusiveL, date *hghV, bit inclusiveH);







/* Exported signatures */

crackers_export str CRKsizeCrackerInsertions(int *k, int *bid);
crackers_export str CRKsizeCrackerDeletions(int *k, int *bid);
crackers_export str CRKprintCrackerInsertions(int *k, int *bid);
crackers_export str CRKprintCrackerDeletions(int *k, int *bid);
crackers_export str CRKmergeInsertions_Forget(int *k, int *bid, int *new);
crackers_export str CRKextendCrackerBAT(int *k, int *bid, lng positions);
crackers_export str CRKmergeInsertionsB_OnNeed(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_OnNeedGradually(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_OnNeedGraduallyRipple(int *k, int *bid, int *new);
crackers_export str CRKmergeDeletions_OnNeed(int *k, int *bid, int *new);
crackers_export str CRKmergeDeletions_OnNeedGradually(int *k, int *bid, int *new);
crackers_export str CRKmergeDeletions_OnNeedGraduallyRipple(int *k, int *bid, int *new);





crackers_export str CRKmergeInsertions_PartiallyForget_chr(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_Force_chr(int *k, int *bid, int *new);




crackers_export str CRKmergeInsertions_PartiallyForget_sht(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_Force_sht(int *k, int *bid, int *new);




crackers_export str CRKmergeInsertions_PartiallyForget_int(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_Force_int(int *k, int *bid, int *new);




crackers_export str CRKmergeInsertions_PartiallyForget_lng(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_Force_lng(int *k, int *bid, int *new);




crackers_export str CRKmergeInsertions_PartiallyForget_flt(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_Force_flt(int *k, int *bid, int *new);




crackers_export str CRKmergeInsertions_PartiallyForget_dbl(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_Force_dbl(int *k, int *bid, int *new);




crackers_export str CRKmergeInsertions_PartiallyForget_date(int *k, int *bid, int *new);
crackers_export str CRKmergeInsertionsB_Force_date(int *k, int *bid, int *new);







#endif /* _CRACKERS_UPDATES_H */

