
#ifndef _MKEY_H
#define _MKEY_H
#include <mal.h>
#include "mal_interpreter.h"
#include "mal_exception.h"

#ifdef WIN32
#ifndef LIBMKEY
#define mkey_export extern __declspec(dllimport)
#else
#define mkey_export extern __declspec(dllexport)
#endif
#else
#define mkey_export extern
#endif

#define GDK_ROTATE(x,y,z,m) ((((x) << (y)) & ~(m)) | (((x) >> (z)) & (m)))

mkey_export str  MKEYrotate(int *ret, int *v, int *nbits);
mkey_export str  MKEYhash(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);
mkey_export str  MKEYhash_bit(int *ret, bit *v);
mkey_export str  MKEYhash_chr(int *ret, chr *v);
mkey_export str  MKEYhash_bte(int *ret, bte *v);
mkey_export str  MKEYhash_sht(int *ret, sht *v);
mkey_export str  MKEYhash_int(int *ret, int *v);
mkey_export str  MKEYhash_flt(int *ret, flt *v);
mkey_export str  MKEYhash_wrd(int *ret, wrd *v);
mkey_export str  MKEYhash_dbl(int *ret, dbl *v);
mkey_export str  MKEYhash_lng(int *ret, lng *v);
mkey_export str  MKEYhash_str(int *ret, str *v);
mkey_export str  MKEYrotate_xor_hash(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);
mkey_export str  MKEYbulk_rotate_xor_hash(int *ret, int *hid, int *nbits,int *bid);

#endif /* _MKEY_H */

