
#ifndef _MAL_BPM
#define _MAL_BPM
#include "mal.h"
#include "mal_client.h"
#include "mal_interpreter.h"

/* #define _DEBUG_BPM_ */

#ifdef WIN32
#ifndef LIBBPM
#define bpm_export extern __declspec(dllimport)
#else
#define bpm_export extern __declspec(dllexport)
#endif
#else
#define bpm_export extern
#endif

bpm_export str BPMopen(void);
bpm_export str BPMclose(int *ret);
bpm_export str BPMdestroy(int *ret);
bpm_export str BPMdeposit(bat *ret, str *nme, bat *src);

bpm_export str BPMrange(bat *ret, bat *bid, ptr low, ptr hgh);
bpm_export str BPMsplitpartition(bat *ret, bat *bid, ptr val);
bpm_export str BPMrangeVector(bat *ret, bat *bid, bat *pv);
bpm_export str BPMrangeVectorSort(bat *ret, bat *bid, bat *pv);
bpm_export str BPMsortPartitions(int *ret, bat *bid);
bpm_export str BPMhashPartitions(int *ret, bat *bid);

bpm_export int BPMisPartitioned(bat src);
bpm_export str BPMpieces(int *ret, bat *src);

/* some primitives replacing the algebra/aggr versions */
bpm_export str BPMcount(int *ret, bat *src);
bpm_export str BPMemptySet(int *ret, bat *src);
bpm_export str BPMsortTail(int *ret, bat *src);

bpm_export str BPMaddPartition(int *ret, bat *dst, bat *src);
bpm_export str BPMhash(bat *ret, bat *bid, int *slots);
bpm_export str BPMderived(bat *ret, bat *bid, bat *src);
bpm_export str BPMadapt(bat *ret, bat *bid, ptr low, ptr hgh, bat *rs, int *pol);
bpm_export str BPMoracle(bat *ret, bat *bid, ptr low, ptr hgh, bat *rs );

bpm_export str BPMtakeIndexed(bat *ret, int *nme);
bpm_export str BPMtake(bat *ret, str *nme);
bpm_export str BPMtakePartition(bat *ret, str *nme, ptr *hl, ptr *hh, ptr *tl, ptr *th);
bpm_export str BPMtakePartitionIndexed(bat *ret, int *bid, int *idx, ptr *hl, ptr *hh, ptr *tl, ptr *th);

bpm_export str BPMexpand(MalBlkPtr mb, int varid, int bid);

bpm_export str BPMunfold(bat *ret, bat *bid);
bpm_export str BPMfold(int *ret, bat *src);
bpm_export str BPMgarbage(int *ret, int *bid);

bpm_export str BPMinsert(bat *ret, bat *bid, bat *ins);
bpm_export str BPMdelete(bat *ret, bat *bid, bat *del);
bpm_export str BPMreplace(bat *ret, bat *bid, bat *ins, bat *del);

bpm_export str BPMgetNames(bat *bid);
bpm_export str BPMdiscard(int *ret, bat *bid);
bpm_export str BPMdiscardAll(int *ret);

bpm_export str BPMnew(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMnewIterator2(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMnewIterator3(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMnewIterator(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMnewIteratorRng(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMnewIteratorRng4(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);

bpm_export str BPMhasMoreElements(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMhasMoreElements2(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMhasMoreElements3(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMhasMoreElementsRng(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
bpm_export str BPMhasMoreElementsRng4(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);

bpm_export str BPMgetNumberOfPartitions(int *ret, int *bid);
bpm_export str BPMselect(int *ret, int *bid, ptr low, ptr hgh);
bpm_export str BPMselectInclusive(int *ret, int *bid, ptr low, ptr hgh, bit *li, bit *hi);

bpm_export str BPMgetDimension(ptr *first, ptr *last,
	ptr *vlow, ptr *vhgh, bat *bid);
bpm_export str BPMdump(int *ret);
bpm_export str BPMdumpAlias(int *ret, bat *bid);

bpm_export str BPMmapname(int *ret);
bpm_export str BPMmapbid(int *ret);
bpm_export str BPMmapalias(int *ret);
bpm_export str BPMmapnxt(int *ret);
bpm_export str BPMmapprv(int *ret);
bpm_export str BPMmaptlowlng(int *ret);
bpm_export str BPMmaptlowdbl(int *ret);
bpm_export str BPMmapthghlng(int *ret);
bpm_export str BPMmapthghdbl(int *ret);

bpm_export str BPMsaveCatalog(int *ret);

bpm_export str BPMsplitquant(bat *ret, bat *bid, int *mb);

bpm_export str BPMprelude(int *ret);
bpm_export str BPMepilogue(int *ret);
#endif

