
#ifndef _LANGUAGE_H
#define _LANGUAGE_H
#include "mal.h"
#include "mal_module.h"
#include "mal_session.h"
#include "mal_resolve.h"
#include "mal_client.h"
#include "mal_interpreter.h"

#ifdef WIN32
#ifndef LIBLANGUAGE
#define language_export extern __declspec(dllimport)
#else
#define language_export extern __declspec(dllexport)
#endif
#else
#define language_export extern
#endif

language_export str CMDraise(str *ret, str *msg);
language_export str MALassertBit(int *ret, bit *val, str *msg);
language_export str MALassertStr(int *ret, str *val, str *msg);
language_export str MALassertOid(int *ret, oid *val, str *msg);
language_export str MALassertSht(int *ret, sht *val, str *msg);
language_export str MALassertInt(int *ret, int *val, str *msg);
language_export str MALassertLng(int *ret, lng *val, str *msg);
language_export str MALstartDataflow( MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
language_export str CMDregisterFunction(int *ret, str *m, str *f, str *code, str *help);
language_export str CMDcallString(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
language_export str CMDevalFile(int *ret, str *fnme);
language_export str CMDcallBAT(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
language_export str CMDincludeFile(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
language_export str CMDdebug(int *ret, int *flg);
language_export str MALassertTriple(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);
language_export str MALsafeguardStack(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);
#endif /* _LANGUAGE_H */

