
#ifndef _MAL_FCN_H
#define _MAL_FCN_H

#include "mal_module.h"
#include "mal_resolve.h"

typedef struct lifespan {
	short beginLifespan, endLifespan, lastUpdate;
} *Lifespan, LifespanRecord;

#define getLastUpdate(L,I)	(L[I].lastUpdate)
#define getEndLifespan(L,I)	(L[I].endLifespan)
#define getBeginLifespan(L,I)	(L[I].beginLifespan)

/* #define DEBUG_MAL_FCN */
/* #define DEBUG_CLONE */

mal_export Symbol   newFunction(str nme,int kind);
mal_export void     renameFunction(str oldmod, str oldfcn,str modnme, str new);
mal_export void	    clearFcn(MalBlkPtr m);
mal_export int      getPC(MalBlkPtr mb, InstrPtr p);

mal_export InstrPtr newCall(Module scope, str fcnname, int kind);
mal_export Symbol cloneFunction(Module scope, Symbol proc, MalBlkPtr mb, InstrPtr p);

mal_export Symbol   getFunctionSymbol(Module scope, InstrPtr p);
mal_export void chkFlow(MalBlkPtr mb);
mal_export void chkDeclarations(MalBlkPtr mb);
mal_export void clrDeclarations(MalBlkPtr mb);
mal_export int getBarrierEnvelop(MalBlkPtr mb);
mal_export int isLoopBarrier(MalBlkPtr mb, int pc);
mal_export int getBlockExit(MalBlkPtr mb,int pc);
mal_export int getBlockBegin(MalBlkPtr mb,int pc);

#define newLifespan(M) (Lifespan)GDKmalloc(sizeof(LifespanRecord)*(M)->vsize)
mal_export void setLifespan(MalBlkPtr mb, Lifespan span);
mal_export void debugLifespan(MalBlkPtr mb, Lifespan span);

mal_export void printFunction(stream *fd, MalBlkPtr mb, int listing);
mal_export void showFlowGraph(MalBlkPtr mb, MalStkPtr stk, str fname);

#include "mal_exception.h"

#define MAXDEPTH 32
#endif /*  _MAL_FCN_H*/

