
#ifndef _MAL_INTERPRET_H
#define _MAL_INTERPRET_H

#include "mal_client.h"
#include "mal_factory.h"
#include "mal_profiler.h"




/*#define DEBUG_MAL_INTERPRETER */
/*#define DEBUG_MAL_PARALLEL */
/*#define STACKTRACE*/
mal_export void showErrors(void);
mal_export MalStkPtr prepareMALstack(MalBlkPtr mb);
mal_export str runMAL(Client c, MalBlkPtr mb, int startpc,
			MalBlkPtr mbcaller, MalStkPtr env, InstrPtr pcicaller);
mal_export str runMALdataflow( Client cntxt, MalBlkPtr mb, int startpc, 
		int stoppc, MalStkPtr stk, MalStkPtr env, InstrPtr pcicaller);
mal_export str reenterMAL(Client cntxt, MalBlkPtr mb, int startpc,
	int stoppc, MalStkPtr stk, MalStkPtr env, InstrPtr pcicaller);
mal_export str callMAL(Client cntxt, MalBlkPtr mb, MalStkPtr *glb, 
	ValPtr argv[], char debug);
mal_export void garbageElement(ValPtr v);
mal_export void garbageCollector(MalBlkPtr mb, MalStkPtr stk, int flag);
mal_export void releaseBAT(MalBlkPtr mb, MalStkPtr stk, int bid);
mal_export int getVolume(MalStkPtr stk, InstrPtr pci, int rd);

mal_export ptr getArgValue(MalStkPtr stk, InstrPtr pci, int k);
mal_export ptr getArgReference(MalStkPtr stk, InstrPtr pci, int k);



mal_export str runMALdataflow( Client cntxt, MalBlkPtr mb, int startpc, 
		int stoppc, MalStkPtr stk, MalStkPtr env, InstrPtr pcicaller);


mal_export str safeguardStack(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);


#endif /*  _MAL_INTERPRET_H*/



