
#ifndef _PRINT_H_
#define _PRINT_H_

#include <mal.h>
#include <mal_interpreter.h>
#include <blob.h>

typedef struct {
	int up, down;
} bipipe;

typedef FILE *fstream;

#define fileCheck(fp) if (!fp) \
	throw(MAL,  "io.@1","Incorrect file pointer");

#ifdef WIN32
#ifndef LIBMAL_IO
#define io_export extern __declspec(dllimport)
#else
#define io_export extern __declspec(dllexport)
#endif
#else
#define io_export extern
#endif

io_export str IOprint_tables(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);
io_export str IOtableAll(stream *f, MalBlkPtr mb, MalStkPtr stk, InstrPtr pci,
int i, int order, int printhead, int printorderby);
io_export str IOprintBoth(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci, int indx,
str hd, str tl, int nobat);
io_export str IOprint_formatted_nil(stream *fd, str format, char last);
io_export str IOprintBoth(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci, int indx,
str hd, str tl, int nobat);
io_export str IOprint_val(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);
io_export str IOprint_tables(MalBlkPtr mb, MalStkPtr stk, InstrPtr p);
io_export str IOprompt_val(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOprint_ft(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOtableAll(stream *f, MalBlkPtr mb, MalStkPtr stk, InstrPtr pci,
int i, int order, int printhead, int printorder);
io_export str IOotable(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOtable(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOfotable(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOftable(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOttable(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOtotable(MalBlkPtr mb, MalStkPtr stk, InstrPtr pci);
io_export str IOprint_str(int *ret, str *s);
io_export str IOprint_formatted_nil(stream *fd, str format, char last);
io_export str IOprint_formatted_lng(int *ret, str *format, lng *val);
io_export str IOprint_formatted_str(int *ret, ptr fmt, str *s);
io_export str IOprint_oid(int *ret, ptr fmt, oid *s);
io_export str IOprint_formatted_bit(int *ret, ptr fmt, bit *s);
io_export str IOexport(int *ret, int *bid, str *fnme);
io_export str IOdatafile(str *ret, str *fnme);
io_export str IOimport(int *ret, int *bid, str *fnme);
io_export str io_stdin(bstream **ret);
io_export str io_stdout(stream **ret);
io_export str io_stderr(stream **ret);

#endif /* _PRINT_H_ */


