

#ifndef _MAL_SABAOTH_DEF
#define _MAL_SABAOTH_DEF

#include <mal.h>
#include <mal_exception.h>


mal_export void SABAOTHinit(str dbfarm, str dbname);


mal_export str SABAOTHmarchScenario(int *ret, str *lang);


mal_export str SABAOTHretreatScenario(int *ret, str *lang);


mal_export str SABAOTHmarchConnection(int *ret, str *host, int *port, bit *ssl);


mal_export str SABAOTHgetLocalConnection(str *ret);


mal_export str SABAOTHwildRetreat(int *ret);


mal_export str SABAOTHregisterStart(int *ret);


mal_export str SABAOTHregisterStop(int *ret);



typedef struct Ssablist {
	str val;                 /* list value */
	struct Ssablist* next;   /* pointer to the next available value*/
} sablist;

typedef enum {
	SABdbIllegal = 0,
	SABdbRunning,
	SABdbCrashed,
	SABdbInactive
} SABdbState;

typedef struct Ssabdb {
	str dbname;              /* database name */
	str path;                /* full path to database */
	int locked;              /* whether this database is under maintenance */
	SABdbState state;        /* current database state */
	sablist* scens;          /* scenarios available for this database */
	sablist* conns;          /* connections available for this database */
	struct Ssabdb* next;     /* next database */
} sabdb;

mal_export str SABAOTHgetMyStatus(sabdb** ret);


/* Caching strategies (might be nice) should create a new struct with
 * the last modified time_t of the files involved, such that a stat is
 * sufficient to see if reparsing is necessary.  The gdk_lock always has
 * to be checked to detect crashes.
 */

mal_export str SABAOTHgetStatus(sabdb** ret, str dbname);
#define MAINTENANCEFILE ".maintenance"


mal_export str SABAOTHfreeStatus(sabdb** ret);


typedef struct Ssabuplog {
	int startcntr;     /* the number of start attempts */
	int stopcntr;      /* the number of successful stop attempts */
	int crashcntr;     /* startcntr - stopcntr (for convenience) */
	time_t avguptime;  /* number of seconds up when not crashing */
	time_t maxuptime;  /* longest uptime when not crashing */
	time_t minuptime;  /* shortest uptime when not crashing */
	time_t lastcrash;  /* time of last crash, -1 if none */
	time_t laststart;  /* time of last start */
	int crashavg1;     /* if there was a crash in the last start attempt */
	double crashavg10; /* average of crashes in the last 10 start attempts */
	double crashavg30; /* average of crashes in the last 30 start attempts */
} sabuplog;

mal_export str SABAOTHgetUplogInfo(sabuplog *ret, sabdb *db);


#endif

